;
; UART I/O 
;
UART_BASE:    	equ 0x8000
UART_TX:      	equ 0
UART_TX_START:	equ 4
UART_TX_READY:	equ 8

setup:
    LI    $t0,UART_BASE   ; Set I/O base address
    LI    $t3,0x0001      ; Set start transmission flag
    LA    $a0,msg         ; Set pointer for text area
output_loop:
    LW    $t1,0($a0)               ; load next word
    BEQ   $t1,$zero,output_end     ; '\0' found?
wait1:
    LW    $t2,UART_TX_READY($t0)   ; while(ready);
    BNE   $t2,$zero,wait1
transmit:
    SW    $t1,UART_TX($t0)         ; Write character
    SW    $t3,UART_TX_START($t0)   ; Start transmission
wait2:
    LW    $t2,UART_TX_READY($t0)   ; while(!ready);
    BEQ   $t2,$zero,wait2
    ADDI  $a0,$a0,4                ; Goto next character
    J     output_loop              ; Next character
output_end:
    J     output_end              ; Wait forever

msg: DC 0x00000048
     DC 0x00000065
     DC 0x0000006c
     DC 0x0000006c
     DC 0x0000006f
     DC 0x00000020
     DC 0x00000057
     DC 0x0000006f
     DC 0x00000072
     DC 0x0000006c
     DC 0x00000064
     DC 0x00000021
     DC 0x0000000a
     DC 0x00000000
